indexing
	description: "Convert string to number"
	project: "http://www.nenie.org/eiffel/"
	license: "http://www.opensource.org/licenses/mit-license.html"
	revision: "$Id: nxml_conversion_private_routines.e,v 1.1 2001/07/10 00:08:34 farnaud Exp $"

class NXML_CONVERSION_PRIVATE_ROUTINES

feature {NONE} -- Implementation
	
	string_to_code (a_string: STRING; a_base: INTEGER): INTEGER is
			-- Convert decimal or hexadecimal number string to integer.
			-- (eg: to numeric part of CharacterRef (entity) to character).
		require
			not_void: a_string /= Void
			good_base: a_base = 10 or a_base = 16
			--good_characters: a_string matches [0-9] with [a-fA-F] if hex
		local
			i: INTEGER
		do
			from
				i := 1
			until
				i > a_string.count
			loop
				-- shift previous result
				Result := Result * a_base
				-- add current digit
				inspect a_string.item (i)
				when '0' then -- do_nothing
				when '1' then Result := Result + 1
				when '2' then Result := Result + 2
				when '3' then Result := Result + 3
				when '4' then Result := Result + 4
				when '5' then Result := Result + 5
				when '6' then Result := Result + 6
				when '7' then Result := Result + 7
				when '8' then Result := Result + 8
				when '9' then Result := Result + 9
				when 'a','A' then Result := Result + 10
				when 'b','B' then Result := Result + 11
				when 'c','C' then Result := Result + 12
				when 'd','D' then Result := Result + 13
				when 'e','E' then Result := Result + 14
				when 'f','F' then Result := Result + 15
				end
				-- next
				i := i + 1
			end
		end

end
