indexing
	description: "PE entity definition and scanner"
	project: "http://www.nenie.org/eiffel/"
	license: "http://www.opensource.org/licenses/mit-license.html"
	revision: "$Id: nxml_pe_entity_def.e,v 1.1 2001/07/10 20:27:52 farnaud Exp $"
	
class NXML_PE_ENTITY_DEF

inherit
	NXML_ENTITY_DEF
		redefine
			read_token,
			reset
		end

creation
	make_literal,
	make_external,
	make_def
	
feature -- Scanner

	read_token is
			-- Redefine token routine to add space before and 
			-- after PE entity
		do
			if not pre_sent then
				pre_sent := True
				last_token := SPACE
				last_value := Normalized_space
			elseif post_sent then
				terminate
			else
				Precursor
				if end_of_file and not post_sent then
					post_sent := True
					last_token := SPACE
					last_value := Normalized_space
				end
			end
		end
		
	reset is
			-- Reset sent
		do
			Precursor
			reset_sent
		end
		
feature {NONE} -- Implementation

	reset_sent is
			-- Reset _sent flags.
		do
			pre_sent := False
			post_sent := False
		end
		
	pre_sent: BOOLEAN
			-- Has the 'before' token been sent?
	post_sent: BOOLEAN
			-- Has the 'after' token been sent?
			
end
